package org.jivesoftware.smackx.ikey.element;

import org.jivesoftware.smackx.ikey.IkeyType;
import org.junit.Test;
import org.jxmpp.jid.EntityBareJid;
import org.jxmpp.jid.impl.JidCreate;

import java.net.URI;
import java.net.URISyntaxException;
import java.util.Arrays;

public class IkeyElementTest {

    @Test
    public void elementTest() throws URISyntaxException {
        IkeyType type = IkeyType.OX;
        SubordinateListElement subordinates = buildSubListElement(
                JidCreate.entityBareFromOrThrowUnchecked("hamlet@denmark.lit"),
                new SubordinateElement(
                        new URI("xmpp:hamlet@denmark.lit?;node=urn:xmpp:openpgp:0:public-keys:1357B01865B2503C18453D208CAC2A9678548E35;item=2020-01-21T10:46:21Z"),
                        "1357B01865B2503C18453D208CAC2A9678548E35"),
                new SubordinateElement(
                        new URI("xmpp:hamlet@denmark.lit?;node=urn:xmpp:omemo:1:bundles;item=123456"),
                        "e64dc9166dd34db64c9247bd502c5969e365a98f3aa41c87247d120487fdd32f")
        );
        ProofElement proof = new ProofElement("d2hpbGUgdGhpcyBpcyBub3QgYSB2YWxpZCBwcm9vZiwgaXQgaXMgc3VmZmljaWVudCBmb3IgdGVzdGluZy4=");

        IkeyElement ikeyElement = new IkeyElement(type, subordinates, proof);

        System.out.println(ikeyElement.toXML().toString());
    }

    private SubordinateListElement buildSubListElement(EntityBareJid jid, SubordinateElement... subordinateElements) {
        return new SubordinateListElement(jid, Arrays.asList(subordinateElements));
    }
}
